# coding: utf-8

import six

from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class ShowAlertRspMalware:

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'malware_family': 'str',
        'malware_class': 'str'
    }

    attribute_map = {
        'malware_family': 'malware_family',
        'malware_class': 'malware_class'
    }

    def __init__(self, malware_family=None, malware_class=None):
        """ShowAlertRspMalware

        The model defined in huaweicloud sdk

        :param malware_family: 恶意家族
        :type malware_family: str
        :param malware_class: 恶意软件分类
        :type malware_class: str
        """
        
        

        self._malware_family = None
        self._malware_class = None
        self.discriminator = None

        if malware_family is not None:
            self.malware_family = malware_family
        if malware_class is not None:
            self.malware_class = malware_class

    @property
    def malware_family(self):
        """Gets the malware_family of this ShowAlertRspMalware.

        恶意家族

        :return: The malware_family of this ShowAlertRspMalware.
        :rtype: str
        """
        return self._malware_family

    @malware_family.setter
    def malware_family(self, malware_family):
        """Sets the malware_family of this ShowAlertRspMalware.

        恶意家族

        :param malware_family: The malware_family of this ShowAlertRspMalware.
        :type malware_family: str
        """
        self._malware_family = malware_family

    @property
    def malware_class(self):
        """Gets the malware_class of this ShowAlertRspMalware.

        恶意软件分类

        :return: The malware_class of this ShowAlertRspMalware.
        :rtype: str
        """
        return self._malware_class

    @malware_class.setter
    def malware_class(self, malware_class):
        """Sets the malware_class of this ShowAlertRspMalware.

        恶意软件分类

        :param malware_class: The malware_class of this ShowAlertRspMalware.
        :type malware_class: str
        """
        self._malware_class = malware_class

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShowAlertRspMalware):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
